package tokens

import (
	"time"

	"git.lehouerou.net/laurent/sorare/graphql"
	"git.lehouerou.net/laurent/sorare/types"
)

type TokenOwner struct {
	Deal struct {
		Typename string `graphql:"__typename"`
		Node     struct {
			Id graphql.Id `graphql:"id"`
		} `graphql:"... on Node"`
	} `graphql:"deal"`
	From     time.Time      `graphql:"from"`
	Id       graphql.Id     `graphql:"id"`
	Price    MonetaryAmount `graphql:"price"`
	SettleAt time.Time      `graphql:"settleAt"`
	Token    struct {
		AssetId string `graphql:"assetId"`
	} `graphql:"token"`
	TransferType types.OwnerTransfer `graphql:"transferType"`
	User         struct {
		Slug string `graphql:"slug"`
	} `graphql:"user"`
}
